const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
const z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geral = new Helper.geral();
const loginPage = new Helper.login();
const protractorHelper = require('protractor-helper');
const j = require('../../../json/leitorJson.po.js');
const representanteLegal = require('../../../page-objects/parametrizacao/contabil/representanteLegal.po.js');
const representanteGridId = '123005444842286002572761';
describe('Tela Representante Legal', () => {
	beforeEach(() => {
		browser.get('http://erpteste.teknisa.com/login/');
		loginPage.login(j.getValor('login'), j.getValor('senha'));
		representanteLegal.abrir();
		protractorHelper.waitForElementVisibility(element(by.id(`grid-${representanteGridId}`)));
	});

	afterEach(() => {
		geral.sair();
	});

	it('Deve acessar a tela Representante Legal', () => {
		expect(z.component.header.getTitle()).toBe('Representante Legal');
	});

	it('Deve adicionar uma Representante Legal', () => {
		geral.clickAdicionar();
		representanteLegal.adicionar(j.getValor('codigoRepresentante'), j.getValor('nomeRepresentante'),
			j.getValor('cpf'), j.getValor('qualificacao'), j.getValor('cep'), j.getValor('ddd'),
			j.getValor('telefoneSemDDD'), j.getValor('email'));
		geral.clickSalvar();

		expect(geral.gridHasText(representanteGridId, j.getValor('codigoRepresentante')))
			.toBe(j.getValor('codigoRepresentante'));
		expect(geral.gridHasText(representanteGridId, j.getValor('nomeRepresentante'), 1))
			.toBe(j.getValor('nomeRepresentante'));
	});

	it('Deve editar registro', () => {
		geral.clickGrid('NMREPRES', j.getValor('nomeRepresentante'), representanteGridId);
		geral.clickEditar();
		representanteLegal.editar(j.getValor('nomeRepresentante1'), j.getValor('cpf1'),
			j.getValor('qualificacao1'), j.getValor('cep1'), j.getValor('ddd1'),
			j.getValor('telefoneSemDDD1'), j.getValor('email1'));
		geral.clickSalvar();

		expect(geral.getTextoPorId('CDREPRES'))
			.toBe(j.getValor('codigoRepresentante1'));
		expect(geral.getTextoPorId('NMREPRES'))
			.toBe(j.getValor('nomeRepresentante1'));
		expect(geral.getTextoPorId('NMQUALIFASSINA'))
			.toBe(j.getValor('qualificacao1'));
	});

	it('Deve excluir Representante Legal', () => {
		geral.clickGrid('NMREPRES', j.getValor('nomeRepresentante1'), representanteGridId);
		geral.clickExcluir();
		geral.clickSim();

		expect(geral.getTextoPorId('CDREPRES'))
			.toBeUndefined();
		expect(geral.getTextoPorId('NMREPRES'))
			.toBeUndefined();
		expect(geral.getTextoPorId('NMQUALIFASSINA'))
			.toBeUndefined();
	});
});
